; JU+TE TINY ES4.0
; Drucken
; s. JU+TE 02/91, S. 88, "Unter Druck"

; reass. V.Pohlers 27.04.2022


		cpu	z8601
		assume RP:0C0h		; prevent register optimization thru AS

; AS-Funktionen
hi	function x,(x>>8)&255
lo	function x, x&255
;

rp 		equ	0FDh		; Register pointer

byte_15		equ 	15h
byte_64		equ	64h
centr		equ	17A6h 		; Druckerausgabe byte_15 auf Port 2, Centronic-Interface

		org 0F512h
		
druck:		push	byte_15
		cp	byte_15, #0Dh	; CR ?
		jr	NZ, druck1
		call	centr
druck1:		push	rp		; Register pointer
		srp	#60h
		ld	R0, #hi(codtab)
		ld	R1, #lo(codtab)
		ld	R2, #8
		ld	R4, byte_15
druck2:		lde	R3, @RR0
		cp	R3, R4		; sichern
		jr	Z, druck4	; Sonderzeichen gefunden
		inc	R1
		djnz	R2, druck2
; 
druck3:		ld	byte_15, R4	; Zeichen rcksichern
		pop	rp		; Register pointer
		call	centr		; ausgeben
		; ESC R 0 select charset USA
		ld	byte_15, #1Bh	; ESC
		call	centr
		ld	byte_15, #52h	; R
		call	centr
		clr	byte_15		; 00
		call	centr
		pop	byte_15
		ret
; Umlaute 
; ESC R 2 select charset germany
druck4:		add	R5, #8		; Offset
		lde	R4, @RR0
		push	byte_64		; R4 sichern
		ld	byte_15, #1Bh	; ESC
		call	centr
		ld	byte_15, #52h	; R
		call	centr
		ld	byte_15, #2	; 2
		call	centr
		pop	byte_64		; Zeichen
		jr	druck3		; drucken

		db  65h ; 1A 
		db  66h ; 1B 
		db  67h ; 1C 
		db  3Fh ; 1D 
		db  3Ch ; 1E 
		db  3Ah ; 1F 

; ES40-Code -> epson charset germany		
codtab:		db  1Ah	;  
		db  1Bh ; 
		db  1Ch ; 
		db  1Dh ; 
		db  1Eh ; 
		db  1Fh ; 
		db  7Fh ; 
		db  8Dh ; ENT?
; Umsetzung ASCII
		db  7Bh ; {
		db  7Ch ; |
		db  7Dh ; }
		db  5Bh ; [
		db  5Ch ; bs
		db  5Dh ; ]
		db  7Eh ; ~
		db  0Ah

;
		db  0

		end
